#include "cpg_islands.h"

/*********************************************/
/*   Add a new CGI at the CGIsss structure   */
/*********************************************/
int add_CGI(struct CGI **cgi, int *nb, int begin, int end, int CpG_nb, int GpC_nb, int G_nb, int C_nb, int A_nb, int T_nb, int N_nb)
{
*nb+=1;
*cgi=(struct CGI *) my_realloc(*cgi, *nb*sizeof(struct CGI), "add_island");

(*cgi+*nb-1)->begin=begin;
(*cgi+*nb-1)->end=end;
(*cgi+*nb-1)->lg=N_nb;


if (N_nb > 0)
	(*cgi+*nb-1)->gc=((double)(G_nb+C_nb))/((double)N_nb);
else
	(*cgi+*nb-1)->gc=-1.0;
					
if (C_nb != 0 && G_nb != 0)
	(*cgi+*nb-1)->cpgoe=((double)N_nb*CpG_nb)/((double)C_nb*G_nb);
else
	(*cgi+*nb-1)->cpgoe=-1.0;
	
if (GpC_nb != 0)
	(*cgi+*nb-1)->cpg_gpc=((double)CpG_nb)/((double)GpC_nb);
else
	(*cgi+*nb-1)->cpg_gpc=-1.0;

if ((G_nb+C_nb) != 0)
	(*cgi+*nb-1)->GCskew=((double)((double)G_nb - C_nb))/((double)((double)G_nb+C_nb));
else
	(*cgi+*nb-1)->GCskew=-1.0;

if ((A_nb+T_nb) != 0)
	(*cgi+*nb-1)->ATskew=((double)((double)A_nb - T_nb))/((double)((double)A_nb+T_nb));
else
	(*cgi+*nb-1)->ATskew=-1.0;
return 1;
}
#include "cpg_islands.h"

/*********************************************/
/*   Compute CpG, GpC, G, C and N number     */
/*              on a segment                 */
/*********************************************/
int compute_CpG_GpC_G_C_nb(char *seq, int beg, int end, int *CpG_nb, int *GpC_nb, int *G_nb, int *C_nb, int *A_nb, int *T_nb, int *N_nb)
{
int ii, jj;

*CpG_nb=*GpC_nb=*C_nb=*G_nb=*A_nb=*T_nb=*N_nb=0;

for (ii=beg; ii <= end; ii++)
	{
	switch (toupper(seq[ii]))
		{
		case 'C': *C_nb+=1;
			  *N_nb+=1;
			  jj = ii+1;
			  while (jj <= end && seq[jj] == '-')
		       	  jj++;
			  if (jj <= end)
				if (toupper(seq[jj]) == 'G')
					*CpG_nb+=1;
			  break;
		case 'G': *G_nb+=1;
			  *N_nb+=1;
			  jj = ii+1;
			  while (jj <= end && seq[jj] == '-')
		       	  jj++;
			  if (jj <= end)
				if (toupper(seq[jj]) == 'C')
					*GpC_nb+=1;
			 break;
		case 'A': *A_nb+=1;
			  *N_nb+=1;
			 break;
		case 'T': *T_nb+=1;
			  *N_nb+=1;
			 break;
				
		}
	}
return *N_nb;
}
#include "cpg_islands.h"

int group_CGIs(char *seq, struct CGI **cgi, int cgi_nb, struct parameters prmt)
{
int ii, jj;
int CpG_nb, GpC_nb, G_nb, C_nb, A_nb, T_nb, N_nb;
int test;

for (ii=0; ii <(cgi_nb-1); ii++)
	{
	if (((*cgi+ii)->end+prmt.mx_lg_between_i) >= (*cgi+ii+1)->begin)	
		{
		compute_CpG_GpC_G_C_nb(seq, (*cgi+ii)->begin, (*cgi+ii+1)->end, &CpG_nb, &GpC_nb, &G_nb, &C_nb, &A_nb, &T_nb, &N_nb);
		test=T;
		if (prmt.test_i == VALID)
			test=test_island((*cgi+ii+1)->end-(*cgi+ii)->begin+1, CpG_nb, GpC_nb, G_nb, C_nb, N_nb, prmt);
		if (test == T)	
			{
			(*cgi+ii)->end=(*cgi+ii+1)->end;
			(*cgi+ii)->lg=(*cgi+ii)->end-(*cgi+ii)->begin+1;
				
			if (N_nb > 0)
				(*cgi+ii)->gc=((double)(G_nb+C_nb))/((double)N_nb);
			else
				(*cgi+ii)->gc=0.0;
					
			if (C_nb != 0 && G_nb != 0)
				(*cgi+ii)->cpgoe=((double)N_nb*CpG_nb)/((double)C_nb*G_nb);
			else
				(*cgi+ii)->cpgoe=0.0;
	
			if (GpC_nb != 0)
				(*cgi+ii)->cpg_gpc=((double)CpG_nb)/((double)GpC_nb);
			else
				(*cgi+ii)->cpg_gpc=0.0;
				
			for (jj=ii+1; jj<(cgi_nb-1); jj++)
				move_CGI(cgi, jj+1, jj);
			cgi_nb--;
			*cgi=(struct CGI *) my_realloc(*cgi, cgi_nb*sizeof(struct CGI), "group_CGIs");
			ii--;
			}
		}
	}
	
return cgi_nb;
}
#include "cpg_islands.h"

int init_parameters_CpGProD(struct parameters *prmt, char *inputfile, char *outputfile, int *vseq, int *vcgi, int argc, char **argv, int *species, struct startScoreCoef *startSC, struct strandScoreCoef *strandSC, struct sensANDspec *snsp, char *nameHTML, int *html)
{
int ar;
int argc_read=0;
char answ[100];
*species=HOMO;
*html=INVALID;

startSC->COEF_LG=COEF_LG_HOMO;
startSC->COEF_CpG=COEF_CpG_HOMO;
startSC->COEF_GC=COEF_GC_HOMO;
startSC->CONST_START=CONST_START_HOMO;

strandSC->COEF_ATskew=COEF_ATskew_HOMO;
strandSC->COEF_GCskew=COEF_GCskew_HOMO;
strandSC->CONST_SENS=CONST_SENS_HOMO;

snsp->sensivity[0]=SEN_HOMO1;
snsp->sensivity[1]=SEN_HOMO2;
snsp->sensivity[2]=SEN_HOMO3;
snsp->sensivity[3]=SEN_HOMO4;
snsp->sensivity[4]=SEN_HOMO5;
snsp->sensivity[5]=SEN_HOMO6;
snsp->sensivity[6]=SEN_HOMO7;
snsp->sensivity[7]=SEN_HOMO8;
snsp->sensivity[8]=SEN_HOMO9;
snsp->specificity[0]=SPE_HOMO1;
snsp->specificity[1]=SPE_HOMO2;
snsp->specificity[2]=SPE_HOMO3;
snsp->specificity[3]=SPE_HOMO4;
snsp->specificity[4]=SPE_HOMO5;
snsp->specificity[5]=SPE_HOMO6;
snsp->specificity[6]=SPE_HOMO7;
snsp->specificity[7]=SPE_HOMO8;
snsp->specificity[8]=SPE_HOMO9;

prmt->w_lg=500;
prmt->w_st=1;
prmt->mn_w_gc=0.5;
prmt->mn_w_cpg=0.6;
prmt->mn_w_cpg_fgc=0.0;
prmt->mn_i_lg=500;

prmt->test_i=INVALID;
prmt->mn_i_gc=0.5;
prmt->mn_i_cpg=0.6;
prmt->mn_i_cpg_fgc=0.0;

prmt->mn_b=0.7;

prmt->gp_n_i=VALID;
prmt->mx_lg_between_i=200;

prmt->CpG_e=fC_x_fG;


*vseq=INVALID;
*vcgi=INVALID;

if (argc <= 1)
	{
	printf("\nSequence file (FASTA format): ");
	fflush(stdout);	/* ++pac */
	gets(inputfile);

	strcpy(outputfile, inputfile);
	strcat(outputfile, ".CpG");


	printf("Output file [%s]: ", outputfile);
	fflush(stdout);	/* ++pac */
	gets(answ);
	
	if (strlen(answ) > 0)
		strcpy(outputfile, answ);

	printf("HTML output (y/n) [y]: ");
	fflush(stdout);	/* ++pac */
	gets(answ);

	if (strlen(answ) == 0 || strncmp(answ, "y", 1) == 0)
		{
		*html=VALID;
		strcpy(nameHTML, inputfile);
		strcat(nameHTML, ".CpG.html");

		printf("HTML output file [%s]: ", nameHTML);
		fflush(stdout);	/* ++pac */
		gets(answ);
		if (strlen(answ) > 0)
			strcpy(nameHTML, answ);
		}
	else
		*html=INVALID;

	printf("Human or mouse parameters (hum/mus)[hum]: ");
	fflush(stdout);	/* ++pac */
	gets(answ);
	if (strncmp(answ, "mus", 3) == 0)
		*species=MUS;

	printf("Display sequence information (y/n) [n]: ");
	fflush(stdout);	/* ++pac */
	gets(answ);
	if (strncmp(answ, "y", 1) == 0)
		*vseq=VALID;

	printf("Display island information (y/n) [n]: ");
	fflush(stdout);	/* ++pac */
	gets(answ);
	if (strncmp(answ, "y", 1) == 0)
		*vcgi=VALID;
	printf("\n******************************\n");
	}
if (argc != 1 && argc != 0 && argc < 3 )
	return -1;

if (argc > 2)
	{
	strcpy(inputfile, argv[1]);
	strcpy(outputfile, argv[2]);
	}
for (ar=3; ar<argc; ar++)
	{

	if (strcmp(argv[ar], "-html") == 0)
		{
		*html=VALID;
		if ((ar+1) >= argc)
			return -1;
		strcpy(nameHTML, argv[++ar]);
		}

	if (strcmp(argv[ar], "-mus") == 0)
		{
		*species=MUS;
		startSC->COEF_LG=COEF_LG_MUS;
		startSC->COEF_CpG=COEF_CpG_MUS;
		startSC->COEF_GC=COEF_GC_MUS;
		startSC->CONST_START=CONST_START_MUS;
	
		strandSC->COEF_ATskew=COEF_ATskew_MUS;
		strandSC->COEF_GCskew=COEF_GCskew_MUS;
		strandSC->CONST_SENS=CONST_SENS_MUS;

		snsp->sensivity[0]=SEN_MUS1;
		snsp->sensivity[1]=SEN_MUS2;
		snsp->sensivity[2]=SEN_MUS3;
		snsp->sensivity[3]=SEN_MUS4;
		snsp->sensivity[4]=SEN_MUS5;
		snsp->sensivity[5]=SEN_MUS6;
		snsp->sensivity[6]=SEN_MUS7;
		snsp->sensivity[7]=SEN_MUS8;
		snsp->sensivity[8]=SEN_MUS9;
		snsp->specificity[0]=SPE_MUS1;
		snsp->specificity[1]=SPE_MUS2;
		snsp->specificity[2]=SPE_MUS3;
		snsp->specificity[3]=SPE_MUS4;
		snsp->specificity[4]=SPE_MUS5;
		snsp->specificity[5]=SPE_MUS6;
		snsp->specificity[6]=SPE_MUS7;
		snsp->specificity[7]=SPE_MUS8;
		snsp->specificity[8]=SPE_MUS9;
		}
	if (strcmp(argv[ar], "-vs") == 0)
		*vseq=1;

	if (strcmp(argv[ar], "-vc") == 0)
		*vcgi=1;
	}


if (prmt->w_lg < 2 || prmt->w_st < 1 || prmt->mn_w_gc < 0.0 || prmt->mn_w_gc > 1.0 || prmt->mn_w_cpg < 0 || prmt->mn_i_lg < prmt->w_lg || prmt->mn_i_gc < 0.0 || prmt->mn_i_gc > 1.0 || (prmt->gp_n_i == VALID && prmt->mx_lg_between_i < 0) || (prmt->test_i == VALID && (prmt->mn_i_gc < 0.0 || prmt->mn_i_gc > 1.0)) || (prmt->test_i == VALID && prmt->mn_i_cpg < 0) || (prmt->gp_n_i == VALID && prmt->mx_lg_between_i < 0))
	{
	write_error_parameters();
	write_message_syntaxe();
	write_tail(stdout);
	exit(0);
	}

			
return argc;	
}
#include "cpg_islands.h"


int main(int argc, char* argv[])
{
int ii;
int species;
int html;
FILE* outputfileTXT;
char *name_fileTXT;
FILE* outputfileHTML=NULL;
char *name_fileHTML;

int cpg_nb, gpc_nb, C_nb, G_nb, A_nb, T_nb, N_nb;
struct startScoreCoef startSC;
struct strandScoreCoef strandSC;
struct sensANDspec snsp;

char *name_inputfile;
FILE* inputfile;

int verbseq=0;
int verbcgi=0;

/*For sequences*/
struct sequence* sq;
int seq_nb;

/*For CpG islands*/
struct CGI** cgi;
int cgi_nb;
/*For parameters*/
struct parameters prmt;


name_fileHTML= (char *) my_realloc(NULL, 200*sizeof(char), "main");
name_fileTXT= (char *) my_realloc(NULL, 200*sizeof(char), "main");
name_inputfile= (char *) my_realloc(NULL, 200*sizeof(char), "main");


if (init_parameters_CpGProD(&prmt, name_inputfile, name_fileTXT, &verbseq, &verbcgi, argc, argv, &species, &startSC, &strandSC, &snsp, name_fileHTML, &html) == -1)
	{
	write_error_parameters();
	write_message_syntaxe();
	return (0);
	}


if ((inputfile=open_file(name_inputfile, 1)) == NULL)
	{
	write_tail(stdout);
	return (0);
	}

if ((outputfileTXT=open_file(name_fileTXT, 2)) == NULL)
	{
	write_tail(stdout);
	return (0);
	}

if (html == 1)
	{
	if ((outputfileHTML=open_file(name_fileHTML, 2)) == NULL)
		{
		write_tail(stdout);
		return (0);
		}
	}

if ((seq_nb=read_fasta(inputfile, &sq)) == -1 || seq_nb == 0)
	{
	printf("\nERROR: can't read the sequence file %s (FASTA format).\n", name_inputfile);
	exit(0);
	}



 write_table_header(outputfileTXT);
 if (html == 1)
	{
	write_header_html(outputfileHTML, 0);
 	write_table_header_html(name_fileTXT, outputfileHTML);
	}
 if (verbcgi == 1)
        write_table_header(stdout);


cgi= (struct CGI **) my_realloc(NULL, seq_nb*sizeof(struct CGI *), "main");

 for (ii=0; ii < seq_nb; ii++)
 	{
		
	cgi_nb=search_CGIs((sq+ii)->seq, (cgi+ii), prmt);

	if (prmt.gp_n_i == VALID)
		{
		cgi_nb=group_CGIs((sq+ii)->seq, (cgi+ii), cgi_nb, prmt);
		}


	(sq+ii)->cgi_nb=cgi_nb;
	compute_CpG_GpC_G_C_nb((sq+ii)->seq, 1, (sq+ii)->lg, &cpg_nb, &gpc_nb, &G_nb, &C_nb, &A_nb, &T_nb, &N_nb);

	if (N_nb > 0)
		(sq+ii)->gc=((double) G_nb+C_nb) / ((double) N_nb);
	else
		(sq+ii)->gc=0.0;

	if (G_nb > 0 && C_nb > 0)
		(sq+ii)->cpgoe=((double) cpg_nb * N_nb) / ((double) C_nb * G_nb);

	else
		(sq+ii)->cpgoe=0.0;
	predict_promoter(*(cgi+ii), cgi_nb, startSC);
	predict_strand(*(cgi+ii), cgi_nb, strandSC);

	write_CGIs_table_predict((sq+ii)->name, *(cgi+ii), cgi_nb, outputfileTXT);
	if (html == 1)
		write_CGIs_table_predict_html((sq+ii)->name, *(cgi+ii), cgi_nb, outputfileHTML);

	if (verbcgi == 1)
		write_CGIs_table_predict((sq+ii)->name, *(cgi+ii), cgi_nb, stdout);
	if (ii<(seq_nb-1) && html == 1)
		write_CGIs_table_predict_html((sq+ii)->name, *(cgi+ii), -1, outputfileHTML);
	}

write_table_tail(outputfileTXT);

if (html == 1)
	{
	write_table_tail_html(outputfileHTML);
	fprintf(outputfileHTML, "\n<B>Sequence information:</B>");
	write_CGI_picture(sq, cgi, seq_nb, prmt.samescale, outputfileHTML);
	write_tail_html(outputfileHTML);
	}
	
if (verbseq == 1)
    write_sequences_info(sq, seq_nb);
    
for (ii=0; ii < seq_nb; ii++)
	free(*(cgi+ii));
free(cgi);
free(sq);

fclose(outputfileTXT);
if (outputfileHTML != NULL)
	fclose(outputfileHTML);
write_tail(stdout);


return 0;
}
#include "cpg_islands.h"

void move_CGI(struct CGI **cgi, int init, int final)
{
(*cgi+final)->begin=(*cgi+init)->begin;
(*cgi+final)->end=(*cgi+init)->end;
(*cgi+final)->lg=(*cgi+init)->lg;
(*cgi+final)->gc=(*cgi+init)->gc;
(*cgi+final)->cpgoe=(*cgi+init)->cpgoe;
(*cgi+final)->cpg_gpc=(*cgi+init)->cpg_gpc;
}
#include "cpg_islands.h"

/***********************************/
/*   Move the limites of windows   */
/***********************************/
int move_limit(char *seq, int seq_lg, int loc, int *new_loc, int step)
{
int count;
*new_loc=loc;	
count=0;
while(count < step)
	{
	if (*new_loc >= seq_lg)
		return -1;
		
	if (seq[*new_loc] != '-')
		count++;
	*new_loc=*new_loc+1;
	}
	
while(seq[*new_loc] == '-' && *new_loc < seq_lg)
	*new_loc=*new_loc+1;
	
return *new_loc;
}
#include "cpg_islands.h"

/*****************************/
/*   My realloc function     */
/*****************************/
void * my_realloc(void *p_in, size_t size, char *sentence)
{
void * p_out;
if ((p_out = (void *) realloc(p_in, size)) == NULL)
	{
	printf("\nERROR: memory allocation in %s", sentence);
	exit(-1);
	}
return p_out;
} 
#include "cpg_islands.h"

FILE *open_file(char *name, int bit)
/*	bit = 1 : reading
	bit = 2 : writting with test
	bit = 3 : ecriture without test		*/
{
FILE *file=NULL;
char answ[100];
if (bit > 0 && bit < 4)
	{
	if (bit == 1)
		if ((file=fopen(name, "r")) == NULL)
			printf("\nERROR: can't open the file %s.\n", name);

	if (bit == 2)
		{
		if ((file=fopen(name, "r")) != NULL)
			{
			printf("QUESTION: erase the file %s (y/n)[n]:", name);
			fflush(stdout);	/* ++pac */
			gets(answ);
				if (strncmp(answ, "y", 1) == 0)
					{
					bit = 3;
					fclose(file);
					}
				else
					{
					fclose(file);
					file=NULL;
					}			
			}
		else
			{
			bit=3;
			/*fclose(file);          */
			}
		}

	if (bit == 3)
		{				
		if ((file=fopen(name,"w")) == NULL)
			printf("\nERROR: can't open the file %s.\n", name);
		}
	}
else
	printf("\nERROR: bad value for the function open_file\n");
return file;
}
#include "cpg_islands.h"


void predict_promoter(struct CGI *cgi, int cgi_nb, struct startScoreCoef startSC)
{
int ii;
for (ii=0; ii < cgi_nb; ii++)
	{
	(cgi+ii)->score_start=startSC.COEF_LG * (cgi+ii)->lg + startSC.COEF_GC * (cgi+ii)->gc + startSC.COEF_CpG * (cgi+ii)->cpgoe +startSC.CONST_START;
	(cgi+ii)->proba_start=exp((cgi+ii)->score_start) / (1.0 + exp((cgi+ii)->score_start));
	}
}
#include "cpg_islands.h"

void predict_strand(struct CGI *cgi, int cgi_nb, struct strandScoreCoef strandSC)
{
int ii;
for (ii=0; ii < cgi_nb; ii++)
	{
	(cgi+ii)->score_strand=strandSC.COEF_ATskew * (cgi+ii)->ATskew + strandSC.COEF_GCskew * (cgi+ii)->GCskew + strandSC.CONST_SENS;
	(cgi+ii)->proba_strand=exp((cgi+ii)->score_strand) / (1.0 + exp((cgi+ii)->score_strand));
	}
}
#include "cpg_islands.h"

int read_fasta(FILE *file, struct sequence **sq)
{
int ii, kk, ll;
char *tmp;
int step=0;
int seq_nb=0;
int *name_lg=NULL;
int *seq_lg=NULL;
tmp=(char *) my_realloc(NULL, 100 * sizeof(char), "read_fasta");

while(fgets(tmp,100, file) != NULL)
	{
	if (strcmp(tmp, "\n") == 0)
		continue;

	tmp=strtok(tmp, " \t\n");
	
	if (tmp == NULL || strlen(tmp) == 0)
		continue;
		
	if (step == 0 && tmp[0] != '>')
		{

		fseek(file, 0, SEEK_SET);
		return -1;
		}
		
	if (tmp[0] == '>')
		{

		step=1;
		seq_nb++;
		seq_lg=(int*) my_realloc(seq_lg, seq_nb*sizeof(int), "read_fasta");
		name_lg=(int*) my_realloc(name_lg, seq_nb*sizeof(int), "read_fasta");

		*(seq_lg+seq_nb-1)=1;
		*(name_lg+seq_nb-1)=1;
		*(name_lg+seq_nb-1)+=strlen(tmp);

		}
	else
		{
		*(seq_lg+seq_nb-1)+=strlen(tmp);
		}

	}

*sq = (struct sequence *) my_realloc(NULL, seq_nb*sizeof(struct sequence), "read_fasta");

for (ii = 0; ii < seq_nb; ii++)
	{
	(*sq+ii)->name=(char*) my_realloc(NULL, *(name_lg+ii)*sizeof(char), "read_fasta");
	(*sq+ii)->seq=(char*) my_realloc(NULL, *(seq_lg+ii)*sizeof(char), "read_fasta");

	*((*sq+ii)->name)='\0';
	*((*sq+ii)->seq)='\0';
	(*sq+ii)->lg=*(seq_lg+ii)-1;
	}

fseek(file, 0, SEEK_SET);
ii = -1;


while(fgets(tmp,100, file) != NULL)
	{
	if (strcmp(tmp, "\n") == 0)
		continue;

	if (tmp[strlen(tmp)-1] == '\n')
		tmp[strlen(tmp)-1]='\0';
	tmp=strtok(tmp, " \t\n");

	if (tmp[0] == '>')
		{
		ii++;
		kk=1;
		ll=0;
		while(tmp[kk] != '\n' && tmp[kk] != '\0')
			*((*sq+ii)->name+ll++)=tmp[kk++];
		*((*sq+ii)->name+ll)='\0';
		ll=0;
		}
	else 
		{
		kk = 0;
		while(tmp[kk] != '\n' && tmp[kk] != '\0')
			*((*sq+ii)->seq+ll++)=tmp[kk++];
		*((*sq+ii)->seq+ll)='\0';
		}
	}
fseek(file, 0, SEEK_SET);

return seq_nb;
}
#include "cpg_islands.h"

/*************************************/
/*   Search the CGIs on a sequence   */
/*************************************/
int search_CGIs(char *seq, struct CGI **cgi, struct parameters prmt)
{
int seq_lg;
int cgi_nb=0;

int w_begin, w_end;
int CpG_w_nb;
int GpC_w_nb;
int G_w_nb;
int C_w_nb;
int A_w_nb;
int T_w_nb;
int N_w_nb;


int s_begin, s_end;
int CpG_s_nb;
int GpC_s_nb;
int G_s_nb;
int C_s_nb;
int A_s_nb;
int T_s_nb;
int N_s_nb;

int i_begin, i_end;
int CpG_i_nb;
int GpC_i_nb;
int G_i_nb;
int C_i_nb;
int A_i_nb;
int T_i_nb;
int N_i_nb;

*cgi=NULL;

i_begin=i_end=-1;
seq_lg=strlen(seq);
/*First window*/
w_begin=0;
while (seq[w_begin] == '-')
	w_begin++;
	
if (move_limit(seq, seq_lg, w_begin, &w_end, prmt.w_lg-1) == -1)
	{
/*	printf(" little sequence (%d nt)\n", seq_lg);*/
	return 0;
	}

compute_CpG_GpC_G_C_nb(seq, w_begin, w_end, &CpG_w_nb, &GpC_w_nb, &G_w_nb, &C_w_nb, &A_w_nb, &T_w_nb, &N_w_nb);

while(w_end < seq_lg)
	{
       /* printf("\nFentre %d-%d:  %d   %d   %d    %d    %d    %d   %d",  w_begin,  w_end, CpG_w_nb, GpC_w_nb, G_w_nb,C_w_nb, A_w_nb, T_w_nb, N_w_nb);
*/	if (test_window(CpG_w_nb, GpC_w_nb, G_w_nb, C_w_nb, N_w_nb, prmt) == T)
		{
/*                                printf("\t+");             */
		if (w_begin <= i_end)
			{
			if (prmt.test_i == VALID)
				{
				compute_CpG_GpC_G_C_nb(seq, i_begin, w_end, &CpG_i_nb, &GpC_i_nb, &G_i_nb, &C_i_nb, &A_i_nb, &T_i_nb, &N_i_nb);
				if (test_island(i_end-i_begin+1, CpG_i_nb, GpC_i_nb, G_i_nb, C_i_nb, N_i_nb, prmt) == T)
					{
					i_end=w_end;
					}
				}
			else
				{
				i_end=w_end;
				}
			}
		else
			{
			if ((i_end-i_begin+1) >= prmt.mn_i_lg)
				{
				compute_CpG_GpC_G_C_nb(seq, i_begin, i_end, &CpG_i_nb, &GpC_i_nb, &G_i_nb, &C_i_nb, &A_i_nb, &T_i_nb, &N_i_nb);
				if (N_i_nb >= prmt.mn_i_lg)
				  	add_CGI(cgi, &cgi_nb, i_begin, i_end, CpG_i_nb, GpC_i_nb, G_i_nb, C_i_nb, A_i_nb, T_i_nb, N_i_nb);
				
				}
			i_begin=w_begin;
			i_end=w_end;
			}
		}
	
	move_limit(seq, seq_lg, w_begin, &s_begin, prmt.w_st);
	compute_CpG_GpC_G_C_nb(seq, w_begin, s_begin-1, &CpG_s_nb, &GpC_s_nb, &G_s_nb, &C_s_nb, &A_s_nb, &T_s_nb, &N_s_nb);
	CpG_w_nb-=CpG_s_nb;
	GpC_w_nb-=GpC_s_nb;
	C_w_nb-=C_s_nb;
	G_w_nb-=G_s_nb;
	N_w_nb-=N_s_nb;
	
	compute_CpG_GpC_G_C_nb(seq, w_begin, s_begin, &CpG_s_nb, &GpC_s_nb, &G_s_nb, &C_s_nb, &A_s_nb, &T_s_nb, &N_s_nb);
	CpG_w_nb-=CpG_s_nb;
	GpC_w_nb-=GpC_s_nb;	
	
	move_limit(seq, seq_lg, w_end, &s_end, prmt.w_st);
	compute_CpG_GpC_G_C_nb(seq, w_end+1, s_end, &CpG_s_nb, &GpC_s_nb, &G_s_nb, &C_s_nb, &A_s_nb, &T_s_nb, &N_s_nb);
	CpG_w_nb+=CpG_s_nb;
	GpC_w_nb+=GpC_s_nb;
	C_w_nb+=C_s_nb;
	G_w_nb+=G_s_nb;
	N_w_nb+=N_s_nb;
	
	compute_CpG_GpC_G_C_nb(seq, w_end, s_end, &CpG_s_nb, &GpC_s_nb, &G_s_nb, &C_s_nb, &A_s_nb, &T_s_nb, &N_s_nb);
	CpG_w_nb+=CpG_s_nb;
	GpC_w_nb+=GpC_s_nb;
		
	w_begin=s_begin;
	w_end=s_end;
	}
	
if ((i_end-i_begin+1) >= prmt.mn_i_lg)
	{
	compute_CpG_GpC_G_C_nb(seq, i_begin, i_end, &CpG_i_nb, &GpC_i_nb, &G_i_nb, &C_i_nb, &A_i_nb, &T_i_nb, &N_i_nb);
	if (N_i_nb >= prmt.mn_i_lg)
	  add_CGI(cgi, &cgi_nb, i_begin, i_end, CpG_i_nb, GpC_i_nb, G_i_nb, C_i_nb, A_i_nb, T_i_nb, N_i_nb);
	}

return cgi_nb;
}
#include "cpg_islands.h"

/********************************************************/
/*   Test if a segment correspond to CGI's parameters   */
/********************************************************/
int test_island(int lg, int CpG_nb, int GpC_nb, int C_nb, int G_nb, int N_nb, struct parameters prmt)
{
double GC_freq, min_CpGoe, CpGoe_ratio;

if (((double) N_nb / lg) >= prmt.mn_b)
	{
	GC_freq=((double)(G_nb+C_nb))/((double)N_nb);
		
	min_CpGoe=prmt.mn_i_cpg+prmt.mn_i_cpg_fgc*GC_freq;
		
	if (prmt.CpG_e == fC_x_fG)
		CpGoe_ratio=((double)N_nb*CpG_nb)/((double)C_nb*G_nb);
	else
		CpGoe_ratio=((double)CpG_nb)/((double)GpC_nb);
			
	if (GC_freq >= prmt.mn_i_gc && CpGoe_ratio >= min_CpGoe)
		return T;
	else 
		return F;
	}
return F;
}
#include "cpg_islands.h"

/**************************************************************/
/*   Test if a window correspond to the window's parameters   */
/**************************************************************/
int test_window(int CpG_nb, int GpC_nb, int G_nb, int C_nb, int N_nb, struct parameters prmt)
{
double GC_freq;
double min_CpGoe;
double CpGoe_ratio;

if ((((double) N_nb) / prmt.w_lg) >= prmt.mn_b)
	{
	GC_freq=((double)G_nb+C_nb)/((double) N_nb);

	min_CpGoe=prmt.mn_w_cpg+prmt.mn_w_cpg_fgc*GC_freq;
		
	if (prmt.CpG_e == fC_x_fG)
		{
		if (C_nb != 0 && G_nb != 0)
			CpGoe_ratio=((double) N_nb*CpG_nb)/((double) C_nb*G_nb);
		else
			CpGoe_ratio=0.0;
		}
	else
		{
		if (GpC_nb != 0)
			CpGoe_ratio=((double) CpG_nb)/((double) GpC_nb);
		else
			CpGoe_ratio=0.0;
		}
	/*printf(" %f   %f   %f    %f", prmt.mn_w_gc, GC_freq, min_CpGoe, CpGoe_ratio);*/
/*  printf("\n %d   %d   %d   %d   %d   %f    %d    %f     %f    %f   %f",CpG_nb, GpC_nb, G_nb, C_nb, N_nb,  prmt.mn_b, prmt.CpG_e,   prmt.mn_w_gc, GC_freq, CpGoe_ratio,min_CpGoe);
   */
	if (GC_freq >= prmt.mn_w_gc && CpGoe_ratio >= min_CpGoe)
		return T;
	else 
		return F;
	}
return F;
}
#include "cpg_islands.h"

#define PIXNBMAX 750

int write_CGI_picture(struct sequence* sq, struct CGI** cgi, int seq_nb, int samescale, FILE *file)
{
int ii, jj;
int lgmax=0;
int begin;
int pixnb;
char color_used_start[10];
struct CGI * cgi_tmp;
/*cgi_tmp=(struct CGI *) my_realloc(NULL, 1 * sizeof(struct CGI)*/
int fd;

for (jj=0; jj <seq_nb; jj++)
	if ((sq+jj)->lg > lgmax)
		lgmax=(sq+jj)->lg;

for (jj=0; jj <seq_nb; jj++)
	{
	begin=1;
	fd=0;
	if (samescale == INVALID)
		lgmax=(sq+jj)->lg;

	cgi_tmp=*(cgi+jj);

		/*printf("\n   %d  %d %d/////   %d   %f  %f   %f  ", &cgi, cgi, *(cgi+jj), (*(cgi+jj))->lg, (*(cgi+jj))->gc, (*(cgi+jj))->cpgoe, (*(cgi+jj))->proba_start);*/
	fprintf(file, "\n\
<BR><TABLE BORDER=0>\n\
<TR>\n\
<TD  ALIGN=left WIDTH=150>%s</TD>\n\
<TD  ALIGN=left WIDTH=80>lg=%dbp</TD>\n\
<TD  ALIGN=leftWIDTH=80>nb_CGIs=%d</TD>\n\
<TD  ALIGN=leftWIDTH=80>G+C=%.4f</TD>\n\
<TD  ALIGN=leftWIDTH=80>CpGo/e=%.4f</TD>\n\
</TR></TABLE>\n", (sq+jj)->name, (sq+jj)->lg, (sq+jj)->cgi_nb, (sq+jj)->gc, (sq+jj)->cpgoe);

	fprintf(file, "\n\
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n\
<TR>\n\
<TD BGCOLOR=#f0f0f0>\n\
<IMG SRC=%scpgprod_begin.gif WIDTH=2 HEIGHT=14 BORDER=0></TD>", PATHPICTURES);

	for (ii=0; ii < (sq+jj)->cgi_nb; ii++)
		{

		strcpy(color_used_start, COLOR4);
   		if ((cgi_tmp+ii)->proba_start < SCOR1)
    			strcpy(color_used_start, COLOR1);
 		else  if ((cgi_tmp+ii)->proba_start < SCOR2)
   			strcpy(color_used_start, COLOR2);
  		else if ((cgi_tmp+ii)->proba_start < SCOR3)
   		 	strcpy(color_used_start, COLOR3);
 		else if ((cgi_tmp+ii)->proba_start < SCOR4)
    			strcpy(color_used_start, COLOR4);

		pixnb= ((double) PIXNBMAX) * ((double)(*(cgi+jj) +ii)->begin-begin+1) / ((double) lgmax);

		if (fd == 1)
			pixnb-=6;

		if ((cgi_tmp+ii)->proba_strand <= 0.5)
			pixnb-=6;
		
		if (pixnb <= 0)
			pixnb=1;

		/*printf("\n<BR>  2: %d    %d", pixnb, (cgi_tmp+ii)->begin-begin+1);*/

		fprintf(file, "\n\
<TD BGCOLOR=#f0f0f0>\n\
<IMG SRC=%scpgprod_seq.gif WIDTH=%d HEIGHT=2 BORDER=0></TD>\n", PATHPICTURES, pixnb);

		if ((cgi_tmp+ii)->proba_strand <= 0.5)
			fprintf(file, "<TD BGCOLOR=#f0f0f0><IMG SRC=%scpgprod_fg.gif WIDTH=6 HEIGHT=14 BORDER=0></TD>\n", PATHPICTURES);
		else
			fprintf(file, "\n\
<TD BGCOLOR=%s>\n\
<IMG SRC=%scpgprod_cgi2.gif WIDTH=2 HEIGHT=14 BORDER=0></TD>\n", color_used_start, PATHPICTURES);

		pixnb= (((double) PIXNBMAX) * ((double)(cgi_tmp+ii)->lg) / ((double) lgmax)) - 4;
	
		if (pixnb <= 0)
			pixnb=1;

		/*printf("\n<BR>  3: %d    %d", pixnb, (cgi_tmp+ii)->lg);*/
		
		fprintf(file, "\n\
<TD BGCOLOR=%s>\n\
<IMG SRC=%scpgprod_cgi1.gif WIDTH=%d HEIGHT=14 BORDER=0 ALT=\"CGI%d lg=%dbp G+C=%.3f CpGo/e=%.3f start-score=%f\"></TD>\n", color_used_start, PATHPICTURES, pixnb, ii+1, (*(cgi+jj)+ii)->lg, (cgi_tmp+ii)->gc, (cgi_tmp+ii)->cpgoe, (cgi_tmp+ii)->proba_start);

	if ((cgi_tmp+ii)->proba_strand > 0.5)
			{
			fprintf(file, "\n\
<TD BGCOLOR=#f0f0f0>\n\
<IMG SRC=%scpg_prod_fd.gif WIDTH=6 HEIGHT=14 BORDER=0></TD>\n", PATHPICTURES);
			fd=1;
			}
		else
			{
			fprintf(file, "\n\
<TD BGCOLOR=%s>\n\
<IMG SRC=%scpgprod_cgi2.gif WIDTH=2 HEIGHT=14 BORDER=0></TD>\n\
", color_used_start, PATHPICTURES);
			fd=0;
			}	


		begin=(cgi_tmp+ii)->end+1;

		}

	pixnb= ((double) PIXNBMAX) * ((double)(sq+jj)->lg-begin+1) / ((double) lgmax);

	if (pixnb <= 0)
		pixnb=1;
	/*printf("\n<BR>  4: %d     %d", pixnb, (sq+jj)->lg-begin+1  );*/
	fprintf(file, "\n\
<TD BGCOLOR=#f0f0f0>\n\
<IMG SRC=%scpgprod_seq.gif WIDTH=%d HEIGHT=2 BORDER=0></TD>\n", PATHPICTURES, pixnb);
	fprintf(file, "\n</TR>\n</TABLE>\n\n");
	}
fprintf(file, "\n<HR>\n");

return 1;
}
#include "cpg_islands.h"

int write_CGIs_table_predict(char * seq_name, struct CGI *cgi, int cgi_nb, FILE * file)
{
int ii;
char strand[10];
double strnd_proba_tmp;

for (ii=0; ii <cgi_nb; ii++)
    {
    if((cgi+ii)->proba_strand >= 0.5)
	{
	strcpy(strand, "plus");
	strnd_proba_tmp=(cgi+ii)->proba_strand;
	}
    else
	{
	strcpy(strand, "minus");
	strnd_proba_tmp=1-(cgi+ii)->proba_strand;
	}

    fprintf(file, "%s\t%d/%d\t%d\t%d\t%d\t%f\t%f\t%f\t%f\t%f\t%s (%f)\n", seq_name, ii+1, cgi_nb, (cgi+ii)->begin+1, (cgi+ii)->end+1, (cgi+ii)->lg, (cgi+ii)->gc, (cgi+ii)->cpgoe, (cgi+ii)->ATskew, (cgi+ii)->GCskew, (cgi+ii)->proba_start, strand, strnd_proba_tmp);
    }
 if (cgi_nb == 0)
   fprintf(file, "%s\t0/0\t\t\t\t\t\t\t\t\t\n", seq_name);
fflush(file);
return cgi_nb;
}
#include "cpg_islands.h"

int write_CGIs_table_predict_html(char * seq_name, struct CGI *cgi, int cgi_nb, FILE *file)
{
int ii;
char color_used_start[10];
char *color_used_strand;
char *color_used;
char strand[10];
double strnd_proba_tmp;

for (ii=0; ii <cgi_nb; ii++)
    {

    if ((cgi+ii)->proba_start < SCOR1)
    	strcpy(color_used_start, COLOR1);
   else  if ((cgi+ii)->proba_start < SCOR2)
    	strcpy(color_used_start, COLOR2);
   else if ((cgi+ii)->proba_start < SCOR3)
    	strcpy(color_used_start, COLOR3);
   else if ((cgi+ii)->proba_start < SCOR4)
    	strcpy(color_used_start, COLOR4);

   color_used_strand=color_used_start;
   color_used=color_used_start;

   if ((cgi+ii)->proba_strand >= 0.5)
	{
	strcpy(strand, "plus");
	strnd_proba_tmp=(cgi+ii)->proba_strand;
	}
else
	{
	strcpy(strand, "minus");
	strnd_proba_tmp=1-(cgi+ii)->proba_strand;
	}

    fprintf(file, "\n<TR>\n\
    <TD ALIGN=\"left\"><FONT COLOR=%s>%s</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=%s>%d/%d</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=%s>%d</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=%s>%d</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=%s>%d</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=%s>%.4f</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=%s>%.4f</FONT></TD>\n\
    <TD ALIGN=\"center\"  BGCOLOR=\"%s\"><FONT COLOR=%s>%.4f</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=%s>%.4f</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=%s>%.4f</FONT></TD>\n\
    <TD ALIGN=\"center\"  BGCOLOR=\"%s\"><FONT COLOR=%s>%s (%.4f)</FONT></TD>\n\
       </TR>", color_used, seq_name, color_used, ii+1, cgi_nb, color_used, (cgi+ii)->begin+1, color_used, (cgi+ii)->end+1, color_used, (cgi+ii)->lg, color_used, (cgi+ii)->gc, color_used, (cgi+ii)->cpgoe, BACKGCLOR, color_used, (cgi+ii)->proba_start, color_used, (cgi+ii)->ATskew, color_used, (cgi+ii)->GCskew, BACKGCLOR, color_used_start, strand, strnd_proba_tmp);

    }
 if (cgi_nb == 0)
   fprintf(file, "\n<TR>\n\
    <TD ALIGN=\"left\">%s </TD>\n\
    <TD ALIGN=\"center\">0/0  </TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=\"#F0F0F0\"> ****</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=\"#F0F0F0\"> ****</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=\"#F0F0F0\"> ****</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=\"#F0F0F0\"> ****</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=\"#F0F0F0\"> ****</FONT></TD>\n\
    <TD ALIGN=\"center\" BGCOLOR=\"%s\"><FONT COLOR=\"%s\"> ****</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=\"#F0F0F0\"> ****</FONT></TD>\n\
    <TD ALIGN=\"center\"><FONT COLOR=\"#F0F0F0\"> ****</FONT></TD>\n\
    <TD ALIGN=\"center\" BGCOLOR=\"%s\"><FONT COLOR=\"%s\"> ****</FONT></TD>\n\
    </TR>", seq_name, BACKGCLOR, BACKGCLOR, BACKGCLOR, BACKGCLOR);


 else if (cgi_nb == -1)
   fprintf(file, "\n<TR>\n\
	<TD><FONT SIZE=1 COLOR=\"#F0F0F0\">.</FONT></TD>\n\
	<TD><FONT SIZE=1 COLOR=\"#F0F0F0\">.</FONT></TD>\n\
	<TD><FONT SIZE=1 COLOR=\"#F0F0F0\">.</FONT></TD>\n\
	<TD><FONT SIZE=1 COLOR=\"#F0F0F0\">.</FONT></TD>\n\
	<TD><FONT SIZE=1 COLOR=\"#F0F0F0\">.</FONT></TD>\n\
	<TD><FONT SIZE=1 COLOR=\"#F0F0F0\">.</FONT></TD>\n\
	<TD><FONT SIZE=1 COLOR=\"#F0F0F0\">.</FONT></TD>\n\
	<TD BGCOLOR=\"%s\"><FONT SIZE=1 COLOR=\"#F0F0F0\">.</FONT></TD>\n\
	<TD><FONT SIZE=1 COLOR=\"#F0F0F0\">.</FONT></TD>\n\
	<TD><FONT SIZE=1 COLOR=\"#F0F0F0\">.</FONT></TD>\n\
	<TD BGCOLOR=\"%s\"><FONT SIZE=1 COLOR=\"#F0F0F0\">.</FONT></TD>\n\
</TR>\n", BACKGCLOR, BACKGCLOR);

fflush(file);
return cgi_nb;
}
#include "cpg_islands.h"

void write_error_parameters(void)
{
printf("\nError: parameter format");
}
#include "cpg_islands.h"

void write_error_sequences(void)
{
printf("\nError: sequence format");
}
#include "cpg_islands.h"

void write_header_html(FILE *file, int cgi)
{
if (cgi == 1)
	fprintf(file, "Content-type: text/html\n\n");

fprintf(file, "\n<HEAD>\n\
<HEAD><TITLE>CpGProD: result</TITLE></HEAD>\n\
<BODY BGCOLOR=\"#F0F0F0\">\n\
<TABLE CELLPADDING=2>\n\
<TR>\n\
<TD><IMG SRC=\"%spbil.gif\" ALT=\"PBIL\"></TD>\n\
<TD><H1>CpGProD (CpG Island Promoter Detection)</H1>\n\
<P>\n\
<A HREF=\"http://biomserv.univ-lyon1.fr\">BBE</A> contribution to<A HREF=\"/pbil.html\">PBIL</A> in Lyon, France\n\
</TD>\n\
</TR>\n\
</TABLE>\n\
<HR>\n\
\n\
<B>CpGProD output:</B>\n\
<BR>\n\
<BR>A table with the CpG island characteristics (one line per CpG island):\n\
<UL>\n\
	<LI><B>sequence name: 	</B>	name of the sequence   ;-)\n\
	<LI><B>number: 		</B>	number of CpG islands found over the sequence\n\
	<LI><B>begin:		</B>	beginning of the CpG island (from 1 to the length of the sequence)\n\
	<LI><B>end: 		</B>	end of the CpG island (from 1 to the length of the sequence)\n\
	<LI><B>length: 		</B>	length of the CpG island (excluding the undetermined nucleotides)\n\
	<LI><B>G+C frequency:	</B>	G+C frequency of the CpG island\n\
	<LI><B>CpGo/e ratio: 	</B>	CpGo/e ratio of the CpG island\n\
	<LI><B><FONT COLOR=\"red\">start-p:</FONT>		</B> 	predicted probability to be located over the transcription start site (range from 0 to 1)\n\
	<LI><B>AT skew: 	</B>	AT skew value of the CpG island\n\
	<LI><B>GC skew: 	</B>	GC skew value of the CpG island\n\
	<LI><B><FONT COLOR=\"red\">strand and (strand-p):</FONT></B> 	strand of the promoter and predicted probability to be located over this strand (range from 0.5 to 1).\n\
</UL>\n\
<BR>Pictures with sequence information (one picture per sequence):\n\
<UL>\n\
	<LI>name of the sequence					\n\
	<LI>length of the sequence					\n\
	<LI>number of CpG islands found over the sequence		\n\
	<LI>G+C frequency of the sequence			\n\
	<LI>CpGo/e ratio  of the sequence			\n\
	<LI>A picture indicating the location, the orientation (black arrow) and the start-p value (color code) observed for each CpG island\n\
</UL>\n\
<BR>\n\
<CENTER>\n\
<IMG SRC=\"http://pbil.univ-lyon1.fr/binaries/home.gif\">\n\
<A HREF=\"http://pbil.univ-lyon1.fr/software/cpgprod.html\">\n\
Go to the CpGProD home page\n\
</A>\n\
<IMG SRC=\"http://pbil.univ-lyon1.fr/binaries/home.gif\">\n\
</CENTER>\n\
<HR>\n\
", PATHPICTURES, PATHHOME);



fflush(file);
}
#include "cpg_islands.h"

#define HELP_MESSAGE "\n\
***********************************\n\
Syntaxe: \n\
CpGProD interactive mode\n\
CpGProD inputfile outputfile [-vs] [-vi] [-mus] [-html filename]\n\
***********************************\n\
inputfile:    file with sequence (mase format)\n\
outputfile:   file with CpG islands informations\n\
                    sequence_name\n\
                    sequence_length\n\
                    CpG islands number\n\
                    begin_island\n\
		    end_island\n\
		    length_island\n\
		    (G+C)_frequency_island\n\
		    CpGo/e_calculate_with_C_and_G_frequencies\n\
		    CpGo/e_calculate_with_GpC_observed\n\
***********************************\n\
   option -vs	    to display sequence information\n\
   option -vc	    to display island information\n\
\n\
   option -mus      to use the  mouse (and other muridae) parameters to predict promoter regions\n\
\n\
   option -html:    to output file at HTML format\n\
	filename	  name of the file\n\
\n\
***********************************\n"

void write_message_syntaxe()
{
printf(HELP_MESSAGE);

}



#include "cpg_islands.h"

void write_sequences_info(struct sequence *sq, int seq_nb)
{
int ii;
int tot=0;

for (ii=0; ii < seq_nb; ii++)
	tot+=(sq+ii)->lg;

printf("\n******************************\n\nSequence information:  %d sequences (%d bp)", seq_nb, tot);

printf("\n\
numero\tSequence names\tlength (bp)\tCGI number\t(G+C) frequency\tCpGo/e ratio\n");

for (ii=0; ii < seq_nb; ii++)
 	printf("%d\t%s\t%d\t%d\t%f\t%f\n",ii+1, (sq+ii)->name, (sq+ii)->lg, (sq+ii)->cgi_nb, (sq+ii)->gc, (sq+ii)->cpgoe);
printf("\n******************************\n");
}
#include "cpg_islands.h"

void write_table_header(FILE *file)
{
fprintf(file, "seq_name\tnumber\tbegin\tend\tlength (bp)\tG+C frequency\tCpGo/e ratio\tAT skew\tGC skew\tstart-p\tstrand (strand-p)\n");
fflush(file);
}
#include "cpg_islands.h"

void write_table_header_html(char * name_outputfile, FILE *file)
{
fprintf(file, "\n<B>CpG island information:</B>\n\
<A HREF=%s>text format</A>",name_outputfile);
fprintf(file, "\n\
<BR><BR>Color code for start-p values: \n\
<TABLE BORDER=\"0\" CELLSPACING=0>\n\
<TR>\n\
<TD ALIGN=left>0</TD>\n\
<TD COLSPAN=2 ALIGN=center>%.2f</TD>\n\
<TD COLSPAN=2 ALIGN=center>%.2f</TD>\n\
<TD COLSPAN=2 ALIGN=center>%.2f</TD>\n\
<TD ALIGN=right>1</TD>\n\
</TR>\n\
<TR>\n\
<TD BGCOLOR=\"%s\"> <FONT COLOR=%s>******</FONT></TD>\n\
<TD BGCOLOR=\"%s\"> <FONT COLOR=%s>******</FONT></TD>\n\
<TD BGCOLOR=\"%s\"> <FONT COLOR=%s>******</FONT></TD>\n\
<TD BGCOLOR=\"%s\"> <FONT COLOR=%s>******</FONT></TD>\n\
<TD BGCOLOR=\"%s\"> <FONT COLOR=%s>******</FONT></TD>\n\
<TD BGCOLOR=\"%s\"> <FONT COLOR=%s>******</FONT></TD>\n\
<TD BGCOLOR=\"%s\"> <FONT COLOR=%s>******</FONT></TD>\n\
<TD BGCOLOR=\"%s\"> <FONT COLOR=%s>******</FONT></TD>\n\
</TR>\n\
</TABLE>\n\
", SCOR1, SCOR2, SCOR3, COLOR1, COLOR1, COLOR1, COLOR1, COLOR2, COLOR2, COLOR2, COLOR2, COLOR3, COLOR3, COLOR3, COLOR3, COLOR4, COLOR4, COLOR4, COLOR4);

fprintf(file, "\n\
<BR>\n\
<TABLE BORDER=\"2\">\n\
<TR>\n\
<TD ALIGN=\"center\"><B>sequence name</B></TD>\n\
<TD ALIGN=\"center\"><B>number</B></TD>\n\
<TD ALIGN=\"center\"><B>begin</B></TD>\n\
<TD ALIGN=\"center\"><B>end</B></TD>\n\
<TD ALIGN=\"center\"><B>length (bp)</B></TD>\n\
<TD ALIGN=\"center\"><B>G+C frequency</B></TD>\n\
<TD ALIGN=\"center\"><B>CpGo/e ratio</B></TD>\n\
<TD ALIGN=\"center\" BGCOLOR=\"%s\"><B>start-p</B></TD>\n\
<TD ALIGN=\"center\"><B>AT skew</B></TD>\n\
<TD ALIGN=\"center\"><B>GC skew</B></TD>\n\
<TD ALIGN=\"center\" BGCOLOR=\"%s\"><B>strand  (strand-p<FONT COLOR=\"red\">*</FONT>)</B></TD>\n\
</TR>", BACKGCLOR, BACKGCLOR);
}
#include "cpg_islands.h"

void write_table_tail(FILE *file)
{
fprintf(file, "");
}
#include "cpg_islands.h"

void write_table_tail_html(FILE *file)
{
fprintf(file, "\n</TABLE>\n");
fprintf(file, "\n<BR> <FONT COLOR=\"red\">*</FONT> A strand-p about 0.50 corresponding to an orientation chosen at random<BR><HR>\n");
fflush(file);
}
#include "cpg_islands.h"

void write_tail(FILE *file)
{
fprintf(file, "\nEnd of the program \nBye bye ;-)\n");
fflush(file);
}
#include "cpg_islands.h"

void write_tail_html(FILE *file)
{
fprintf(file, "\n\
<ADDRESS>\
<A HREF=\"/comments.html\">If you have problems or comments...</A>\n\
<P>\n\
<A HREF=\"http://pbil.univ-lyon1.fr\"><IMG SRC=\"%shome.gif\"></A>\n\
Back to PBIL home page\n\
</BODY>", PATHPICTURES);
fflush(file);
}
